Index: pjproject/trunk/pjsip/build/pjsip.dsw
===================================================================
--- pjproject/trunk/pjsip/build/pjsip.dsw	(revision 236)
+++ pjproject/trunk/pjsip/build/pjsip.dsw	(revision 238)
@@ -138,4 +138,19 @@
     Project_Dep_Name pjsip_simple
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name pjsua_lib
+    End Project Dependency
+}}}
+
+###############################################################################
+
+Project: "pjsua_lib"=.\pjsua_lib.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
 }}}
 
Index: pjproject/trunk/pjsip/build/pjsip.sln
===================================================================
--- pjproject/trunk/pjsip/build/pjsip.sln	(revision 236)
+++ 	(revision )
@@ -1,117 +1,0 @@
-Microsoft Visual Studio Solution File, Format Version 8.00
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_core_lib", "pjsip_core.vcproj", "{6A2C9762-EB5C-44B3-BC41-471DA2D0234A}"
-	ProjectSection(ProjectDependencies) = postProject
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78} = {A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_ua_lib", "pjsip_ua.vcproj", "{B05FA649-6AD8-42E3-986D-C6E95E206B76}"
-	ProjectSection(ProjectDependencies) = postProject
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A} = {6A2C9762-EB5C-44B3-BC41-471DA2D0234A}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib", "..\..\pjlib\build\pjlib.vcproj", "{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjmedia_lib", "..\..\pjmedia\build\pjmedia.vcproj", "{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}"
-	ProjectSection(ProjectDependencies) = postProject
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78} = {A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsua", "pjsua.vcproj", "{DBEC405B-6E6E-419E-BE29-FF6AFC8FEC70}"
-	ProjectSection(ProjectDependencies) = postProject
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78} = {A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE} = {B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}
-		{B05FA649-6AD8-42E3-986D-C6E95E206B76} = {B05FA649-6AD8-42E3-986D-C6E95E206B76}
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A} = {6A2C9762-EB5C-44B3-BC41-471DA2D0234A}
-		{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9} = {99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_core_test", "pjsip_core_test.vcproj", "{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}"
-	ProjectSection(ProjectDependencies) = postProject
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78} = {A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A} = {6A2C9762-EB5C-44B3-BC41-471DA2D0234A}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_simple_lib", "pjsip_simple.vcproj", "{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Global
-	GlobalSection(SourceCodeControl) = preSolution
-		SccNumberOfProjects = 8
-		SccProjectName0 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath0 = ..\\..
-		SccProvider0 = MSSCCI:Microsoft\u0020Visual\u0020SourceSafe
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection0 = pjsip\\build\\
-		SolutionUniqueID = {084A6F63-C2AA-4AF1-B551-6F4550ACB44F}
-		SccProjectUniqueName1 = ..\\..\\pjlib\\build\\pjlib.vcproj
-		SccLocalPath1 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection1 = pjlib\\build\\
-		SccProjectUniqueName2 = ..\\..\\pjmedia\\build\\pjmedia.vcproj
-		SccLocalPath2 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection2 = pjmedia\\build\\
-		SccProjectUniqueName3 = pjsip_core.vcproj
-		SccLocalPath3 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection3 = pjsip\\build\\
-		SccProjectUniqueName4 = pjsip_ua.vcproj
-		SccLocalPath4 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection4 = pjsip\\build\\
-		SccProjectUniqueName5 = pjsua.vcproj
-		SccLocalPath5 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection5 = pjsip\\build\\
-		SccProjectUniqueName6 = pjsip_core_test.vcproj
-		SccLocalPath6 = ..\\..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection6 = pjsip\\build\\
-		SccProjectUniqueName7 = pjsip_simple.vcproj
-		SccProjectName7 = \u0022$/pjproject/pjsip\u0022,\u0020QIAAAAAA
-		SccLocalPath7 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection7 = build\\
-	EndGlobalSection
-	GlobalSection(SolutionConfiguration) = preSolution
-		Debug = Debug
-		Release = Release
-	EndGlobalSection
-	GlobalSection(ProjectConfiguration) = postSolution
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A}.Debug.ActiveCfg = Debug|Win32
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A}.Debug.Build.0 = Debug|Win32
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A}.Release.ActiveCfg = Release|Win32
-		{6A2C9762-EB5C-44B3-BC41-471DA2D0234A}.Release.Build.0 = Release|Win32
-		{B05FA649-6AD8-42E3-986D-C6E95E206B76}.Debug.ActiveCfg = Debug|Win32
-		{B05FA649-6AD8-42E3-986D-C6E95E206B76}.Debug.Build.0 = Debug|Win32
-		{B05FA649-6AD8-42E3-986D-C6E95E206B76}.Release.ActiveCfg = Release|Win32
-		{B05FA649-6AD8-42E3-986D-C6E95E206B76}.Release.Build.0 = Release|Win32
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}.Debug.ActiveCfg = Debug|Win32
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}.Debug.Build.0 = Debug|Win32
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}.Release.ActiveCfg = Release|Win32
-		{A0EC3D31-5FC2-45A5-85FB-76376FBBBD78}.Release.Build.0 = Release|Win32
-		{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}.Debug.ActiveCfg = Debug|Win32
-		{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}.Debug.Build.0 = Debug|Win32
-		{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}.Release.ActiveCfg = Release|Win32
-		{99D06BCE-43AE-40B6-AD4F-14261AB7C5D9}.Release.Build.0 = Release|Win32
-		{DBEC405B-6E6E-419E-BE29-FF6AFC8FEC70}.Debug.ActiveCfg = Debug|Win32
-		{DBEC405B-6E6E-419E-BE29-FF6AFC8FEC70}.Debug.Build.0 = Debug|Win32
-		{DBEC405B-6E6E-419E-BE29-FF6AFC8FEC70}.Release.ActiveCfg = Release|Win32
-		{DBEC405B-6E6E-419E-BE29-FF6AFC8FEC70}.Release.Build.0 = Release|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Debug.ActiveCfg = Debug|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Debug.Build.0 = Debug|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Release.ActiveCfg = Release|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Release.Build.0 = Release|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Debug.ActiveCfg = Debug|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Debug.Build.0 = Debug|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Release.ActiveCfg = Release|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Release.Build.0 = Release|Win32
-	EndGlobalSection
-	GlobalSection(ExtensibilityGlobals) = postSolution
-	EndGlobalSection
-	GlobalSection(ExtensibilityAddIns) = postSolution
-	EndGlobalSection
-EndGlobal
Index: pjproject/trunk/pjsip/build/pjsua.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsua.dsp	(revision 236)
+++ pjproject/trunk/pjsip/build/pjsua.dsp	(revision 238)
@@ -91,29 +91,5 @@
 # Begin Source File
 
-SOURCE=..\src\pjsua\getopt.c
-# End Source File
-# Begin Source File
-
 SOURCE=..\src\pjsua\main.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua_call.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua_core.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua_opt.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua_pres.c
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua_reg.c
 # End Source File
 # End Group
@@ -121,12 +97,4 @@
 
 # PROP Default_Filter "h;hpp;hxx;hm;inl"
-# Begin Source File
-
-SOURCE=..\src\pjsua\getopt.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\pjsua\pjsua.h
-# End Source File
 # End Group
 # Begin Group "Resource Files"
Index: pjproject/trunk/pjsip/build/pjsua_lib.dsp
===================================================================
--- pjproject/trunk/pjsip/build/pjsua_lib.dsp	(revision 238)
+++ pjproject/trunk/pjsip/build/pjsua_lib.dsp	(revision 238)
@@ -0,0 +1,126 @@
+# Microsoft Developer Studio Project File - Name="pjsua_lib" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Static Library" 0x0104
+
+CFG=pjsua_lib - Win32 Debug
+!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!MESSAGE use the Export Makefile command and run
+!MESSAGE 
+!MESSAGE NMAKE /f "pjsua_lib.mak".
+!MESSAGE 
+!MESSAGE You can specify a configuration when running NMAKE
+!MESSAGE by defining the macro CFG on the command line. For example:
+!MESSAGE 
+!MESSAGE NMAKE /f "pjsua_lib.mak" CFG="pjsua_lib - Win32 Debug"
+!MESSAGE 
+!MESSAGE Possible choices for configuration are:
+!MESSAGE 
+!MESSAGE "pjsua_lib - Win32 Release" (based on "Win32 (x86) Static Library")
+!MESSAGE "pjsua_lib - Win32 Debug" (based on "Win32 (x86) Static Library")
+!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!IF  "$(CFG)" == "pjsua_lib - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir ".\output\pjsua-lib-i386-win32-vc6-release"
+# PROP BASE Intermediate_Dir ".\output\pjsua-lib-i386-win32-vc6-release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir ".\output\pjsua-lib-i386-win32-vc6-release"
+# PROP Intermediate_Dir ".\output\pjsua-lib-i386-win32-vc6-release"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD CPP /nologo /MD /W4 /GX /O2 /I "../include" /I "../../pjmedia/include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "NDEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /FD /c
+# SUBTRACT CPP /YX
+# ADD BASE RSC /l 0x409 /d "NDEBUG"
+# ADD RSC /l 0x409 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"..\lib\pjsua-lib-i386-win32-vc6-release.lib"
+
+!ELSEIF  "$(CFG)" == "pjsua_lib - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir ".\output\pjsua-lib-i386-win32-vc6-debug"
+# PROP BASE Intermediate_Dir ".\output\pjsua-lib-i386-win32-vc6-debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir ".\output\pjsua-lib-i386-win32-vc6-debug"
+# PROP Intermediate_Dir ".\output\pjsua-lib-i386-win32-vc6-debug"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /GX /ZI /Od /I "../include" /I "../../pjmedia/include" /I "../../pjlib-util/include" /I "../../pjlib/include" /D "_DEBUG" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "WIN32" /D "_MBCS" /D "_LIB" /FD /GZ /c
+# SUBTRACT CPP /YX
+# ADD BASE RSC /l 0x409 /d "_DEBUG"
+# ADD RSC /l 0x409 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo /out:"..\lib\pjsua-lib-i386-win32-vc6-debug.lib"
+
+!ENDIF 
+
+# Begin Target
+
+# Name "pjsua_lib - Win32 Release"
+# Name "pjsua_lib - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\getopt.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\pjsua_call.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\pjsua_core.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\pjsua_opt.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\pjsua_pres.c"
+# End Source File
+# Begin Source File
+
+SOURCE="..\src\pjsua-lib\pjsua_reg.c"
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# Begin Source File
+
+SOURCE="..\include\pjsua-lib\getopt.h"
+# End Source File
+# Begin Source File
+
+SOURCE="..\include\pjsua-lib\pjsua.h"
+# End Source File
+# End Group
+# End Target
+# End Project