Index: /pjproject/trunk/INSTALL.txt
===================================================================
--- /pjproject/trunk/INSTALL.txt	(revision 273)
+++ /pjproject/trunk/INSTALL.txt	(revision 274)
@@ -1,1 +1,40 @@
-Left empty for now.
+[Last update: 2006/03/01]
+
+-= INTRO=-
+
+This top level projects:
+
+ - pjlib:       portability and basic framework library
+ - pjlib-util:  lexical scanner, XML, STUN, MD5, etc.
+ - pjmedia:     media framework and codecs
+ - pjsip:       SIP stacks (core, UA layer, SIMPLE, etc.)
+ - pjsip-apps:  SIP apps (pjsua, pjsip-perf)
+
+
+-= OBJECTIVE =-
+
+Currently we only have two working applications:
+
+ - pjsua:       Console based SIP UA
+ - pjsip-perf:  SIP performance measurement
+
+
+-= COMPILING =-
+
+On Windows:
+ - Open pjsip-apps/build/pjsip_apps.dsw
+ - Build pjsua and pjsip_perf project
+
+With Makefile:
+ - on top level dir (e.g. ~/pjproject)
+ - ./configure && make dep && make clean && make
+
+Binaries will be in pjsip-apps/bin.
+
+
+-= PORTING =-
+
+ - Just need to port pjlib.
+ - PJLIB doc has detailed info how to do this.
+ - Must pass pjlib-test!
+
Index: /pjproject/trunk/README.txt
===================================================================
--- /pjproject/trunk/README.txt	(revision 273)
+++ /pjproject/trunk/README.txt	(revision 274)
@@ -2,2 +2,4 @@
 COPYING in this directory. For alternative licensing, please contact the
 copyright holder.
+
+See INSTALL.txt for compiling.
Index: project/trunk/build/pjproject.dsw
===================================================================
--- /pjproject/trunk/build/pjproject.dsw	(revision 273)
+++ 	(revision )
@@ -1,233 +1,0 @@
-Microsoft Developer Studio Workspace File, Format Version 6.00
-# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
-
-###############################################################################
-
-Project: "pjlib"=..\pjlib\build\pjlib.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjlib/build", UIAAAAAA
-    ..\pjlib\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjlib_test"=..\pjlib\build\pjlib_test.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjlib/build", HICAAAAA
-    ..\pjlib\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "pjlibpp"=..\pjlib\build\pjlibpp.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjlib/build", HICAAAAA
-    ..\pjlib\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjmedia"=..\pjmedia\build\pjmedia.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjmedia/build", MJCAAAAA
-    ..\pjmedia\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjmedia_audio_tool"=..\pjmedia\build\pjmedia_audio_tool.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjmedia/build", MJCAAAAA
-    ..\pjmedia\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjmedia
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "pjmedia_test"=..\pjmedia\build\pjmedia_test.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjmedia/build", MJCAAAAA
-    ..\pjmedia\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjmedia
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "pjsip_core"=..\pjsip\build\pjsip_core.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjsip/build", LJCAAAAA
-    ..\pjsip\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsip_core_test"=..\pjsip\build\pjsip_core_test.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjsip/build", LJCAAAAA
-    ..\pjsip\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_core
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Project: "pjsip_simple"=..\pjsip\build\pjsip_simple.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjsip/build", LJCAAAAA
-    ..\pjsip\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsip_ua"=..\pjsip\build\pjsip_ua.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjsip/build", LJCAAAAA
-    ..\pjsip\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Project: "pjsua"=..\pjsip\build\pjsua.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/pjsip/build", LJCAAAAA
-    ..\pjsip\build
-    end source code control
-}}}
-
-Package=<4>
-{{{
-    Begin Project Dependency
-    Project_Dep_Name pjlib
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjmedia
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_ua
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_core
-    End Project Dependency
-    Begin Project Dependency
-    Project_Dep_Name pjsip_simple
-    End Project Dependency
-}}}
-
-###############################################################################
-
-Global:
-
-Package=<5>
-{{{
-    begin source code control
-    "$/pjproject/build", KYBAAAAA
-    .
-    end source code control
-}}}
-
-Package=<3>
-{{{
-}}}
-
-###############################################################################
-
Index: project/trunk/build/pjproject.sln
===================================================================
--- /pjproject/trunk/build/pjproject.sln	(revision 273)
+++ 	(revision )
@@ -1,187 +1,0 @@
-Microsoft Visual Studio Solution File, Format Version 8.00
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib", "..\pjlib\build\pjlib.vcproj", "{72790D99-35BB-45AC-9A23-3BB60C901E63}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlib_test", "..\pjlib\build\pjlib_test.vcproj", "{A684A4C0-00D6-4497-B144-FC6AED4FAD8A}"
-	ProjectSection(ProjectDependencies) = postProject
-		{72790D99-35BB-45AC-9A23-3BB60C901E63} = {72790D99-35BB-45AC-9A23-3BB60C901E63}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjlibpp", "..\pjlib\build\pjlibpp.vcproj", "{488B9CA1-8F59-4E4E-8748-D6A712CF9F3C}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjmedia_lib", "..\pjmedia\build\pjmedia.vcproj", "{EB8559B2-D738-4987-8591-4D217F8B0099}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjmedia_test", "..\pjmedia\build\pjmedia_test.vcproj", "{692B42C4-6888-4BF8-9613-E48A2F138005}"
-	ProjectSection(ProjectDependencies) = postProject
-		{72790D99-35BB-45AC-9A23-3BB60C901E63} = {72790D99-35BB-45AC-9A23-3BB60C901E63}
-		{EB8559B2-D738-4987-8591-4D217F8B0099} = {EB8559B2-D738-4987-8591-4D217F8B0099}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_core_lib", "..\pjsip\build\pjsip_core.vcproj", "{58A72B82-7369-4B89-B511-7191A6B0D8C3}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_ua_lib", "..\pjsip\build\pjsip_ua.vcproj", "{DEE358A5-ADD3-4403-AD82-4967E63F17D1}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsua", "..\pjsip\build\pjsua.vcproj", "{B8500B7B-C6A8-46B9-84E6-90E200C1B35A}"
-	ProjectSection(ProjectDependencies) = postProject
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE} = {B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3} = {58A72B82-7369-4B89-B511-7191A6B0D8C3}
-		{72790D99-35BB-45AC-9A23-3BB60C901E63} = {72790D99-35BB-45AC-9A23-3BB60C901E63}
-		{DEE358A5-ADD3-4403-AD82-4967E63F17D1} = {DEE358A5-ADD3-4403-AD82-4967E63F17D1}
-		{EB8559B2-D738-4987-8591-4D217F8B0099} = {EB8559B2-D738-4987-8591-4D217F8B0099}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_core_test", "..\pjsip\build\pjsip_core_test.vcproj", "{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}"
-	ProjectSection(ProjectDependencies) = postProject
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3} = {58A72B82-7369-4B89-B511-7191A6B0D8C3}
-		{72790D99-35BB-45AC-9A23-3BB60C901E63} = {72790D99-35BB-45AC-9A23-3BB60C901E63}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjmedia_audio_tool", "..\pjmedia\build\pjmedia_audio_tool.vcproj", "{5FD061CF-A0E8-43DF-990C-B046AA1BF5EE}"
-	ProjectSection(ProjectDependencies) = postProject
-		{72790D99-35BB-45AC-9A23-3BB60C901E63} = {72790D99-35BB-45AC-9A23-3BB60C901E63}
-		{EB8559B2-D738-4987-8591-4D217F8B0099} = {EB8559B2-D738-4987-8591-4D217F8B0099}
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_callgen", "..\pjsip\build\pjsip_callgen.vcproj", "{DCBEF2A3-D444-46FC-82E7-D939113EECA7}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "pjsip_simple_lib", "..\pjsip\build\pjsip_simple.vcproj", "{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}"
-	ProjectSection(ProjectDependencies) = postProject
-	EndProjectSection
-EndProject
-Global
-	GlobalSection(SourceCodeControl) = preSolution
-		SccNumberOfProjects = 13
-		SccLocalPath0 = .
-		CanCheckoutShared = false
-		SolutionUniqueID = {23953A1F-662B-4D0D-BC25-C13C88DE8618}
-		SccProjectUniqueName1 = ..\\pjlib\\build\\pjlib.vcproj
-		SccProjectName1 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath1 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection1 = pjlib\\build\\
-		SccProjectUniqueName2 = ..\\pjlib\\build\\pjlib_test.vcproj
-		SccProjectName2 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath2 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection2 = pjlib\\build\\
-		SccProjectUniqueName3 = ..\\pjlib\\build\\pjlibpp.vcproj
-		SccProjectName3 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath3 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection3 = pjlib\\build\\
-		SccProjectUniqueName4 = ..\\pjmedia\\build\\pjmedia.vcproj
-		SccProjectName4 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath4 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection4 = pjmedia\\build\\
-		SccProjectUniqueName5 = ..\\pjmedia\\build\\pjmedia_test.vcproj
-		SccProjectName5 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath5 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection5 = pjmedia\\build\\
-		SccProjectUniqueName6 = ..\\pjsip\\build\\pjsip_core.vcproj
-		SccProjectName6 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath6 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection6 = pjsip\\build\\
-		SccProjectUniqueName7 = ..\\pjsip\\build\\pjsip_ua.vcproj
-		SccProjectName7 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath7 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection7 = pjsip\\build\\
-		SccProjectUniqueName8 = ..\\pjsip\\build\\pjsua.vcproj
-		SccProjectName8 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath8 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection8 = pjsip\\build\\
-		SccProjectUniqueName9 = ..\\pjsip\\build\\pjsip_core_test.vcproj
-		SccProjectName9 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath9 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection9 = pjsip\\build\\
-		SccProjectUniqueName10 = ..\\pjmedia\\build\\pjmedia_audio_tool.vcproj
-		SccProjectName10 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath10 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection10 = pjmedia\\build\\
-		SccProjectUniqueName11 = ..\\pjsip\\build\\pjsip_callgen.vcproj
-		SccProjectName11 = \u0022$/pjproject\u0022,\u0020PIAAAAAA
-		SccLocalPath11 = ..
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection11 = pjsip\\build\\
-		SccProjectUniqueName12 = ..\\pjsip\\build\\pjsip_simple.vcproj
-		SccProjectName12 = \u0022$/pjproject/pjsip\u0022,\u0020QIAAAAAA
-		SccLocalPath12 = ..\\pjsip
-		CanCheckoutShared = false
-		SccProjectFilePathRelativizedFromConnection12 = build\\
-	EndGlobalSection
-	GlobalSection(SolutionConfiguration) = preSolution
-		Debug = Debug
-		Release = Release
-	EndGlobalSection
-	GlobalSection(ProjectConfiguration) = postSolution
-		{72790D99-35BB-45AC-9A23-3BB60C901E63}.Debug.ActiveCfg = Debug|Win32
-		{72790D99-35BB-45AC-9A23-3BB60C901E63}.Debug.Build.0 = Debug|Win32
-		{72790D99-35BB-45AC-9A23-3BB60C901E63}.Release.ActiveCfg = Release|Win32
-		{72790D99-35BB-45AC-9A23-3BB60C901E63}.Release.Build.0 = Release|Win32
-		{A684A4C0-00D6-4497-B144-FC6AED4FAD8A}.Debug.ActiveCfg = Debug|Win32
-		{A684A4C0-00D6-4497-B144-FC6AED4FAD8A}.Debug.Build.0 = Debug|Win32
-		{A684A4C0-00D6-4497-B144-FC6AED4FAD8A}.Release.ActiveCfg = Release|Win32
-		{A684A4C0-00D6-4497-B144-FC6AED4FAD8A}.Release.Build.0 = Release|Win32
-		{488B9CA1-8F59-4E4E-8748-D6A712CF9F3C}.Debug.ActiveCfg = Debug|Win32
-		{488B9CA1-8F59-4E4E-8748-D6A712CF9F3C}.Debug.Build.0 = Debug|Win32
-		{488B9CA1-8F59-4E4E-8748-D6A712CF9F3C}.Release.ActiveCfg = Release|Win32
-		{488B9CA1-8F59-4E4E-8748-D6A712CF9F3C}.Release.Build.0 = Release|Win32
-		{EB8559B2-D738-4987-8591-4D217F8B0099}.Debug.ActiveCfg = Debug|Win32
-		{EB8559B2-D738-4987-8591-4D217F8B0099}.Debug.Build.0 = Debug|Win32
-		{EB8559B2-D738-4987-8591-4D217F8B0099}.Release.ActiveCfg = Release|Win32
-		{EB8559B2-D738-4987-8591-4D217F8B0099}.Release.Build.0 = Release|Win32
-		{692B42C4-6888-4BF8-9613-E48A2F138005}.Debug.ActiveCfg = Debug|Win32
-		{692B42C4-6888-4BF8-9613-E48A2F138005}.Debug.Build.0 = Debug|Win32
-		{692B42C4-6888-4BF8-9613-E48A2F138005}.Release.ActiveCfg = Release|Win32
-		{692B42C4-6888-4BF8-9613-E48A2F138005}.Release.Build.0 = Release|Win32
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3}.Debug.ActiveCfg = Debug|Win32
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3}.Debug.Build.0 = Debug|Win32
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3}.Release.ActiveCfg = Release|Win32
-		{58A72B82-7369-4B89-B511-7191A6B0D8C3}.Release.Build.0 = Release|Win32
-		{DEE358A5-ADD3-4403-AD82-4967E63F17D1}.Debug.ActiveCfg = Debug|Win32
-		{DEE358A5-ADD3-4403-AD82-4967E63F17D1}.Debug.Build.0 = Debug|Win32
-		{DEE358A5-ADD3-4403-AD82-4967E63F17D1}.Release.ActiveCfg = Release|Win32
-		{DEE358A5-ADD3-4403-AD82-4967E63F17D1}.Release.Build.0 = Release|Win32
-		{B8500B7B-C6A8-46B9-84E6-90E200C1B35A}.Debug.ActiveCfg = Debug|Win32
-		{B8500B7B-C6A8-46B9-84E6-90E200C1B35A}.Debug.Build.0 = Debug|Win32
-		{B8500B7B-C6A8-46B9-84E6-90E200C1B35A}.Release.ActiveCfg = Release|Win32
-		{B8500B7B-C6A8-46B9-84E6-90E200C1B35A}.Release.Build.0 = Release|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Debug.ActiveCfg = Debug|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Debug.Build.0 = Debug|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Release.ActiveCfg = Release|Win32
-		{782BF0C1-FE0E-48A9-B875-31E7BF9F4B5B}.Release.Build.0 = Release|Win32
-		{5FD061CF-A0E8-43DF-990C-B046AA1BF5EE}.Debug.ActiveCfg = Debug|Win32
-		{5FD061CF-A0E8-43DF-990C-B046AA1BF5EE}.Debug.Build.0 = Debug|Win32
-		{5FD061CF-A0E8-43DF-990C-B046AA1BF5EE}.Release.ActiveCfg = Release|Win32
-		{5FD061CF-A0E8-43DF-990C-B046AA1BF5EE}.Release.Build.0 = Release|Win32
-		{DCBEF2A3-D444-46FC-82E7-D939113EECA7}.Debug.ActiveCfg = Debug|Win32
-		{DCBEF2A3-D444-46FC-82E7-D939113EECA7}.Debug.Build.0 = Debug|Win32
-		{DCBEF2A3-D444-46FC-82E7-D939113EECA7}.Release.ActiveCfg = Release|Win32
-		{DCBEF2A3-D444-46FC-82E7-D939113EECA7}.Release.Build.0 = Release|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Debug.ActiveCfg = Debug|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Debug.Build.0 = Debug|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Release.ActiveCfg = Release|Win32
-		{B5C20C39-AF03-405D-BF59-B4C2E8D68BDE}.Release.Build.0 = Release|Win32
-	EndGlobalSection
-	GlobalSection(ExtensibilityGlobals) = postSolution
-	EndGlobalSection
-	GlobalSection(ExtensibilityAddIns) = postSolution
-	EndGlobalSection
-EndGlobal