Index: pjproject/trunk/pjlib/src/pj/config.c
===================================================================
--- pjproject/trunk/pjlib/src/pj/config.c	(revision 278)
+++ pjproject/trunk/pjlib/src/pj/config.c	(revision 279)
@@ -22,5 +22,5 @@
 
 static const char *id = "config.c";
-const char *PJ_VERSION = "0.5.3";
+const char *PJ_VERSION = "0.5.3.1";
 
 PJ_DEF(void) pj_dump_config(void)
Index: pjproject/trunk/pjmedia/build/pjmedia_codec.dsp
===================================================================
--- pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 278)
+++ pjproject/trunk/pjmedia/build/pjmedia_codec.dsp	(revision 279)
@@ -42,5 +42,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
-# ADD CPP /nologo /MD /W4 /GX- /O2 /I "../include" /I "../../pjlib/include" /I "../src/pjmedia-codec" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "HAVE_CONFIG_H" /FD /c
+# ADD CPP /nologo /MD /W4 /O2 /I "../include" /I "../../pjlib/include" /I "../src/pjmedia-codec" /D "NDEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "HAVE_CONFIG_H" /FD /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "NDEBUG"
@@ -66,5 +66,5 @@
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
-# ADD CPP /nologo /MTd /W4 /Gm /GX- /ZI /Od /I "../include" /I "../../pjlib/include" /I "../src/pjmedia-codec" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "HAVE_CONFIG_H" /FR /FD /GZ /c
+# ADD CPP /nologo /MTd /W4 /Gm /ZI /Od /I "../include" /I "../../pjlib/include" /I "../src/pjmedia-codec" /D "_DEBUG" /D "WIN32" /D "_MBCS" /D "_LIB" /D PJ_WIN32=1 /D PJ_M_I386=1 /D "HAVE_CONFIG_H" /FR /FD /GZ /c
 # SUBTRACT CPP /YX
 # ADD BASE RSC /l 0x409 /d "_DEBUG"
@@ -412,128 +412,160 @@
 
 SOURCE="..\src\pjmedia-codec\speex\bits.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\cb_search.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_10_16_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_10_32_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_20_32_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_5_256_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_5_64_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\exc_8_128_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\filters.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\gain_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\gain_table_lbr.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\hexc_10_32_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\hexc_table.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\high_lsp_tables.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\lpc_spx.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\lsp.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\lsp_tables_nb.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\ltp.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\math_approx.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\misc.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\modes.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\nb_celp.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\preprocess_spx.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\quant_lsp.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\sb_celp.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\smallft.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\speex.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\speex_callbacks.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\speex_header.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\stereo.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\vbr.c"
+# ADD CPP /W4
 # End Source File
 # Begin Source File
 
 SOURCE="..\src\pjmedia-codec\speex\vq.c"
+# ADD CPP /W4
 # End Source File
 # End Group
Index: pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h	(revision 278)
+++ pjproject/trunk/pjmedia/src/pjmedia-codec/speex/config.h	(revision 279)
@@ -6,2 +6,14 @@
 
 #include "misc.h"
+
+#if !defined(PJ_HAS_FLOATING_POINT) || PJ_HAS_FLOATING_POINT==0
+#   define FIXED_POINT
+#endif
+
+#ifdef _MSC_VER
+#   pragma warning(disable: 4100)   // unreferenced formal parameter
+#   pragma warning(disable: 4101)   // unreferenced local variable
+#   pragma warning(disable: 4244)   // conversion from 'double ' to 'float '
+#   pragma warning(disable: 4305)   // truncation from 'const double ' to 'float '
+#   pragma warning(disable: 4701)   // local variable used without initialized
+#endif
Index: pjproject/trunk/pjmedia/src/pjmedia/conference.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 278)
+++ pjproject/trunk/pjmedia/src/pjmedia/conference.c	(revision 279)
@@ -890,5 +890,4 @@
 {
     pj_int16_t *buf;
-    pj_bool_t sent = PJ_FALSE;
     unsigned j;
 